package oop1_dat1_u;

/**
 *
 * @author Felix Rohrer <felix.rohrer@stud.hslu.ch>
 */
public class MyLinkedList<T>
{

    private MyListNode<T> head; // Kopf bzw. Anfang der Liste
    private int numOfElements; // Anzahl Elemente in dieser Liste

    public MyLinkedList()
    {
        head = null;
        numOfElements = 0;
    }

    /**
     * Prüft, ob Liste leer ist.
     */
    public boolean isEmpty()
    {
        return (head == null);
    }

    /**
     * Fügt Objekt d am Anfang in die Liste ein.
     */
    public void insert(T d)
    {
        head = new MyListNode<T>(head, d);
        numOfElements++;
    }

    /**
     * Prüft, ob ein gleiches Objekt wie d bereits in der Liste enthalten ist.
     */
    public boolean isFound(T d)
    {
        MyListNode<T> actualNode = head;
        while ((actualNode != null) &&  ! d.equals(actualNode.getData())) {
            actualNode = actualNode.getNext();
        }
        if (actualNode == null) {
            return false;
        } else {
            return true;
        }
    }

    /**
     * Entfernt aus der Liste das erste Objekt gleich d.
     */
    public void remove(T d)
    {
        MyListNode<T> actualNode = head;
        MyListNode<T> prevNode = null;
        while ((actualNode != null) &&  ! d.equals(actualNode.getData())) {
            prevNode = actualNode;
            actualNode = prevNode.getNext();
        }
        // Liste wieder ordentlich zusammenhängen:
        if (actualNode != null) {
            if (actualNode == head) {
                head = actualNode.getNext();
            } else {
                prevNode.setNext(actualNode.getNext());
            }
            numOfElements--;
        }
    }

    /**
     * Gibt alle Objekte der Reihe nach zeilenweise auf die Konsole aus.
     */
    public void print()
    {
        MyListNode<T> actualNode = head;
        System.out.println("----------");
        while (actualNode != null) {
            System.out.println(actualNode.getData());
            actualNode = actualNode.getNext();
        }
    }

    public MyListNode<T> getHead()
    {
        return head;
    }

    public int size()
    {
        return numOfElements;
    }

    // Test
    public static void main_TestMyLinkedList(String[] args)
    {
        MyLinkedList<Konto> list = new MyLinkedList<Konto>();
        list.insert(new Konto(10000.0, 1.5));
        list.insert(new Konto(500.0, 0.7));
        list.insert(new Spar());
        list.print();
        list.remove(new Konto(500.0, 0.7));
        list.print();
    }
}
